package net.tomatentum.cutin;

import java.lang.reflect.Method;
import java.util.List;
import java.util.Optional;

import net.tomatentum.cutin.method.ReflectedMethod;


public interface ReflectedMethodFactory<I extends Object, C extends Object> {
    Optional<ReflectedMethod<I, C>> produce(Method method, Object containingClass);
    ReflectedMethodFactory<I, C> addFactory(Factory<I, C> factory);

    public interface Factory<I extends Object, C extends Object> {

        Optional<ReflectedMethod<I, C>> produce(Method method, Object containingObject);
        void addParser(ReflectedMethod<I, C> method, List<MethodParser> parser);

    }
}