package net.tomatentum.cutin;

import static org.junit.jupiter.api.Assertions.assertTrue;

import org.junit.jupiter.api.Test;

import net.tomatentum.cutin.method.BestCandidateMethod;
import net.tomatentum.cutin.method.ReflectedMethod;

class ReflectedMethodTest {
    
    @Test
    void methodTest() {
        ReflectedMethod<String, String> method = new TestReflectedMethod(new TestMethodClass());
        Object result = method.run("testContext");
        assertTrue((boolean)result);
    }

    @Test
    void testBCMethod() {
        ReflectedMethod<String, Double> method = new BestCandidateMethod<String, Double>(
            "test", 
            new TestMethodClass(),
            "ident",
             "testString");
        Object result = method.run((double)4);
        assertTrue((boolean)result);
    }
}
